#ifndef STRUCT_TABLES_H
#define STRUCT_TABLES_H

/*!
  \file
  \brief ʐMAyѐp̍\̒`

  \author Satofumi KAMIMURA

  $Id$
*/

#include "directDeviceCtrl.h"
#include "directWheelCtrl.h"
#include "modeCtrl.h"


/*!
  \brief s䃂W[Ǘ
*/
typedef struct {

  // system
  long version;
  int msec;
  long sec;
  unsigned short used_msec;

  // device
  encInfo_t enc[2];
  motorInfo_t mtr[2];
  directDeviceInfo_t direct[2];

  // framework
  wheelInfo_t whl[2];
  directWheelInfo_t directWhl[2];
  bodyInfo_t bodyInfo;
  bodyPosition_t bodyPos;
  coordinateInfo_t gl_crd;
  coordinateInfo_t gl_crd_offset;
  coordinateInfo_t run_crd;
  coordinateInfo_t run_crd_offset;
  velocityInfo_t velInfo;

  // manage
  modeInfo_t mode;

  // contorl
  velocityCtrlInfo_t straight;
  velocityCtrlInfo_t rotate;

  // additional
  unsigned long watch_dog_msec;
  unsigned long watch_dog_msec_max;

} runCtrl_t;

#endif /* !STRUCT_TABLES_H */
